//+------------------------------------------------------------------+
//|    Fiboossss_TRO_MOD                                   Fibos.mq4 |
//|                                        Developed by Coders' Guru |
//|                                            http://www.xpworx.com |
//+------------------------------------------------------------------+
//| _TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
 
#property copyright "Coders' Guru"
#property link      "http://www.xpworx.com"
string   ver  = "Last Modified: 2008.02.22 19:20";

#property indicator_chart_window
#property  indicator_buffers 1
#property indicator_color1 Orange

extern int   StartBar = 0;
extern int   BarsBack = 24;


//+------------------------------------------------------------------+
 
double ExtBuffer0[];
double close, retrace, xRange ;    
double higher_point ;
double lower_point ;

int lowest_bar  ;
int highest_bar  ;
  
//+------------------------------------------------------------------+
void CalcFibo()
{ 
 
  lowest_bar   = iLowest(NULL,0,MODE_LOW,BarsBack,StartBar);
  highest_bar  = iHighest(NULL,0,MODE_HIGH,BarsBack,StartBar);
 
  higher_point = iHigh(NULL,0,highest_bar);
  lower_point  = iLow(NULL,0,lowest_bar);
  close        = iClose(NULL,0,0); 
  
  xRange = higher_point - lower_point ; 
  

  if(  lowest_bar >  highest_bar)
  {
     retrace = -100 * (higher_point - close) / xRange ;     
  }
  else
  {
     retrace = 100 * (close - lower_point ) / xRange ;    
  }
   
  ExtBuffer0[0] = retrace ;
  
}

//+------------------------------------------------------------------+

int deinit()
{

   return (0);
}

//+------------------------------------------------------------------+

int init()
{
  SetIndexBuffer(0,ExtBuffer0);


   SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, 4, indicator_color1);

  return(0);
}

//+------------------------------------------------------------------+
int start()
{
  CalcFibo();
  
  return(0);
}
//+------------------------------------------------------------------+






