//+------------------------------------------------------------------+ 
//|  TRO_DYNAMIC_FIBS_SR_EXT                                         | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
#property indicator_chart_window 
#property indicator_buffers 5 
 

//---- input parameters 
  
extern  int      my_bars  = 300; 
extern  int      iPeriods = 5; 
extern  int      my_shift = 0; 

 
//---- buffers 
double DynR[]; 
double DynS[]; 
double RetPct[]; 
double RetPips[]; 
double LastTouch[]; 
 
double    close, high, low   ; 

string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
double point; 
//+------------------------------------------------------------------+ 
int init() 
  { 
//---- indicators 
   SetIndexStyle(0,DRAW_NONE);  
   SetIndexBuffer(0,DynR); 
   SetIndexEmptyValue(0,0.0); 
   
   SetIndexStyle(1,DRAW_NONE); 
   SetIndexBuffer(1,DynS); 
   SetIndexEmptyValue(1,0.0); 
   
   SetIndexStyle(2,DRAW_NONE); 
   SetIndexBuffer(2,RetPct); 
   SetIndexEmptyValue(2,0.0); 

   SetIndexStyle(3,DRAW_NONE); 
   SetIndexBuffer(3,LastTouch); 
   SetIndexEmptyValue(3,0.0);  

   SetIndexStyle(4,DRAW_NONE); 
   SetIndexBuffer(4,RetPips); 
   SetIndexEmptyValue(3,0.0);  
      
   period       =  Period();  
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;   
   digits       =  Digits ;   
   point        =  Point ;
   
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
       
   return(0); 
  }  
//+------------------------------------------------------------------+ 
int deinit() 
  { 
 
   return(0); 
  }  
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
    if(counted_bars < 0) 
        return(-1); 
 
   int limit=Bars-counted_bars; 
    
    
   DynR[0] = close ; 
   DynS[0] = close ;

   int    hh, ll ;
   double nHH, nLL; 
   double range; 

   int processBars=MathMin(limit, my_bars); 
   
   for(int i=processBars; i>=0; i-- )
   {    

         hh = Highest(symbol,period,MODE_HIGH,iPeriods,i); 
         ll = Lowest(symbol,period,MODE_LOW,iPeriods,i); 

         nHH = iHigh(symbol,period,hh) ;
         nLL = iLow(symbol,period,ll) ;

         DynR[i] =   nHH; 
         DynS[i] =   nLL; 

         high    = iHigh(symbol,period,i) ;
         low     = iLow(symbol,period,i) ;

         if( high == DynR[i] ) { LastTouch[i] = 1 ; } else
         if( low  == DynS[i] ) { LastTouch[i] = -1 ; } else
                               { LastTouch[i] = LastTouch[i+1] ; } 
         
         if (( DynR[i] != high ) && (DynR[i] < DynR[i+1]) &&  ( DynR[i+1] != 0 ))     
            DynR[i] = DynR[i+1]; 

         if (( DynS[i] != low ) && (DynS[i] > DynS[i+1] ) && ( DynS[i+1] != 0 )) 
            DynS[i] = DynS[i+1]; 
       
       
            close      = iClose(symbol,period,i) ; 
            range      = DynR[i+my_shift] - DynS[i+my_shift]; 
            
            RetPct[i]  = 100 * ( close - DynS[i+my_shift] ) / range ; 

            if( LastTouch[i] == 1 ) 
               { RetPips[i] = (DynR[i] - close) / point ; } 
            else
               { RetPips[i] = (close - DynS[i]) / point  ; }
 
            
   } //end for 


   return(0); 
  } 
//+------------------------------------------------------------------+ 
 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}


//+--------- TRO MODIFICATION ---------------------------------------+  


/*

if( period == PERIOD_MN1) { Comment("MN LastTouch= ",    DoubleToStr(LastTouch[0] ,0) ) ; }
 

Alert(  DoubleToStr(iAlertShort ,digits), " DYN SR Short ");

Comment(


"High[0]= ",    DoubleToStr(High[0] ,digits) , "\n",
"iAlertShort= ",    DoubleToStr(iAlertShort ,digits) , "\n",
"Bid= ",    DoubleToStr(Bid ,digits) , "\n",
"Low[0]= ",    DoubleToStr(Low[0] ,digits) , "\n",
" ",    "\n",

"High[0]= ",    DoubleToStr(High[0] ,digits) , "\n",
"Ask= ",    DoubleToStr(Ask ,digits) , "\n",
"iAlertBuy= ",    DoubleToStr(iAlertBuy ,digits) , "\n",
"Low[0]= ",    DoubleToStr(Low[0] ,digits) , "\n",


"") ; 

*/