//+------------------------------------------------------------------+
//|   TRO_Fractal_Plot                                               |
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 2

extern bool   Sound.Alert  = true ;
extern bool   Use.Wicks    = true ;

extern color colorFractalHigh    = Red ;
extern color colorFractalLow     = Blue ;
 

extern int BarsAgo   = 100 ;
extern int myPeriod  = 0 ;
extern int myShift   = 1 ;

extern int myStyle  = 0 ; 
extern int myWidth  = 1 ; 

//---- buffers
 


string  tHIGH0 ,tLOW0 ;

string symbol, tChartPeriod,  tShortName, oldmsg = "" ;  
int    digits, period  ; 

double  point  ;
 
double v1[];
double v2[];
double val1,val2 ; 
 
//+------------------------------------------------------------------+
int init()
  {
 
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; } 
      
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }   
   
   tChartPeriod =  TimeFrameToString(period) ;   
   
   string short_name="frPL";
   IndicatorShortName(short_name);

   SetIndexStyle(0, DRAW_NONE );
  
   SetIndexBuffer(0, v1);
 
 
   SetIndexStyle(1, DRAW_NONE);
 
   SetIndexBuffer(1, v2);
 
  tHIGH0  = "fr" + period + "H000" ;
  tLOW0   = "fr" + period + "L000" ;

   return(0);
  }

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+
int deinit()
  {
   ObDeleteObjectsByPrefix("fr" + period );     
    
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{
 
  deinit() ;  
 
val1 = 0 ; 
val2 = 0 ;

   int i;
   
      i = BarsAgo;
      
   while(i >= 0)
     {   
       val1 = iFractals(symbol, period, MODE_UPPER, i);
       
       if(val1 > 0) 
           v1[i] = iHigh(symbol, period, i) ; 
       else
           v1[i] = v1[i+1]; 
           
       val2 = iFractals(symbol, period, MODE_LOWER, i);
        
       if(val2 > 0) 
           v2[i] = iLow(symbol, period, i) ;
       else
           v2[i] = v2[i+1];
       i--;
     } 

 


  if (ObjectFind(tHIGH0) != 0)
      {
      
          ObjectCreate(tHIGH0,OBJ_HLINE,0,Time[myShift],v1[myShift]);         
          ObjectSet(tHIGH0,OBJPROP_COLOR,colorFractalHigh);  
   	    ObjectSet(tHIGH0, OBJPROP_STYLE, myStyle);
   	    ObjectSet(tHIGH0, OBJPROP_WIDTH, myWidth);
      } 
      else
      {
         ObjectMove(tHIGH0,0,Time[myShift],v1[myShift]);
      }
 

    
    if (ObjectFind(tLOW0) != 0)
      {
          ObjectCreate(tLOW0,OBJ_HLINE,0,Time[myShift],v2[myShift]);   
          ObjectSet(tLOW0,OBJPROP_COLOR,colorFractalLow);
   	    ObjectSet(tLOW0, OBJPROP_STYLE, myStyle);
   	    ObjectSet(tLOW0, OBJPROP_WIDTH, myWidth);
      } 
      else
      {
         ObjectMove(tLOW0,0,Time[myShift],v2[myShift]);
      }
   
 

return(0);
}

//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}


//+------------------------------------------------------------------+
/*

Comment(

"val1 " , DoubleToStr(val1,Digits) , "\n" ,   
"val2 " , DoubleToStr(val2,Digits) , "\n" ,   

"v1[myShift] " , DoubleToStr(v1[myShift],Digits) , "\n" ,   
"v2[myShift] " , DoubleToStr(v2[myShift],Digits) , "\n" ,    
"myShift " , myShift , "\n" ,   

"") ;   
 
*/