//+------------------------------------------------------------------+
//|   TRO_Paulus_Plot                                                |
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 


#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window 
#property indicator_buffers 0

extern bool   Sound.Alert  = false ;
extern bool   Show.Comment = true ;
extern int BarsAgo   = 100 ;
extern int myPeriod  = 0 ;
extern double factor   = 0.50 ;
extern double mySLpips   =5 ;

extern color colorPBEntry    = Blue ;
extern color colorPBStop     = Red ;
extern color colorPBTarget   = Green ;

//extern double myRiskReward  = 1.5 ;

//---- buffers
 

string tHIGH0  = "PaulusHIGH_0" ;
string tLOW0   = "PaulusLOW_0" ;
string tTarget = "PaulusTarget" ; 

string symbol, tChartPeriod,  tShortName, oldmsg = "" ;  
int    digits, period  ; 

double xRange, xPct, X01, X02, close, min=99999, max=-1, Open0, Open1, Open2, Close0, Close1, Close2, High0, High1, High2, Low0,  Low1, Low2  ;
double  Range0, Range1, Range2 ;
double  point, target, RiskReward, Entry,  TP, SL  ;

bool PB = false, bTarget = false ; 
 
int xPB ; 
 
datetime Trigger, CurrentTime ; 
 
double  M1_Open, Size, LimitSh, LimitLg, SLpips  ; 
 
 
 
//+------------------------------------------------------------------+
int init()
  {
 
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; } 
      
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }    
   
   tChartPeriod =  TimeFrameToString(period) ;   
   
   string short_name="PaulusPL";
   IndicatorShortName(short_name);

   SLpips = mySLpips * point ;

   return(0);
  }
  
//+------------------------------------------------------------------+
int deinit()
  {
   
   ObjectDelete(tHIGH0);
   ObjectDelete(tLOW0);
   ObjectDelete(tTarget);      
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
{

CurrentTime = TimeMinute(TimeCurrent()) ;
Comment( "" );

   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = 0; i < BarsAgo ; i++)
   {
 
   PB  = false ; 
   PB  = bTarget ;
	xPB = 0 ;
			
	Close0 = iClose(symbol,period,i) ; 
   Close1 = iClose(symbol,period,i+1) ;    
   Close2 = iClose(symbol,period,i+2) ;  
     
   Open0 = iOpen(symbol,period,i) ; 
   Open1 = iOpen(symbol,period,i+1) ;    
   Open2 = iOpen(symbol,period,i+2) ;  

   High0 = iHigh(symbol,period,i) ; 
   High1 = iHigh(symbol,period,i+1) ;    
   High2 = iHigh(symbol,period,i+2) ; 

   Low0 = iLow(symbol,period,i) ; 
   Low1 = iLow(symbol,period,i+1) ;    
   Low2 = iLow(symbol,period,i+2) ;  		
/*
   Range0 = High0 - Low0 ;
   Range1 = High1 - Low1 ;   
   Range2 = High2 - Low2 ;
*/

   Range0 = MathAbs(Close0 - Open0) ;
   Range1 = MathAbs(Close1 - Open1) ;   
   Range2 = MathAbs(Close2 - Open2) ;
         
   Size    = Range1 / Range2 ;
   LimitSh = High2 - (Range2 * factor) ; 
   LimitLg = Low1 + (Range2 * factor) ;   				


   if ( High1 < LimitLg && Size < factor && Close2 < Open2 && Close1 > Open1  && Low1 > Low2 ) 			 
   { 
      PB         = true ; 
      xPB        = i+1 ;   
      xPct       = ( Range1 / Range2 ) * 100 ; 
      RiskReward = (High2 - High1) / (High1 - Low2) ; 
      Entry      = High1 ;
      TP         = High2 ;
//      SL         = MathMax(Low1,Low2) - SLpips ;
      SL         = Low2 - SLpips ;
            
      bTarget    = true ;
      if(Show.Comment)
      {
      Comment( 
//               "Most recent " + tChartPeriod + " Paulus bar was " + xPB + " bars ago" + "\n",
//               "and was " + DoubleToStr(xPct,0)+ "% of preceding bar" + "\n",
//               "Paulus Range = " + DoubleToStr(Range2 / point ,0)  + "\n", 
               "Long Trigger = " + DoubleToStr(Entry  ,digits)  + "\n", 
               "Take Profit  = " + DoubleToStr(TP ,digits)  + "\n", 
               "Stop Loss    = " + DoubleToStr(SL  ,digits)  + "\n",                               
               "Risk/Reward  = " + DoubleToStr(RiskReward ,2) + ":1"               
               ) ;
      } // if
      break ; 
   } // if

   if ( Low1 > LimitSh && Size < factor && Close2 > Open2 && Close1 < Open1  && High1 < High2 ) 			 
   { 
      PB         = true ; 
      xPB        = i+1 ;   
      xPct       = ( Range1 / Range2 ) * 100 ; 
      RiskReward = (Low1 - Low2) / (High2 - Low1) ; 
      Entry      = Low1 ;
      TP         = Low2 ;
//      SL         = MathMin(High1,High2) + SLpips;
      SL         =  High2  + SLpips;      
      bTarget    = true ;
      if(Show.Comment)
      {
      Comment( 
//               "Most recent " + tChartPeriod + " Paulus bar was " + xPB + " bars ago" + "\n",
//               "and was " + DoubleToStr(xPct,0)+ "% of preceding bar" + "\n",
//               "Paulus Range = " + DoubleToStr(Range2 / point ,0)  + "\n", 
               "Short Trigger = " + DoubleToStr(Entry  ,digits)  + "\n", 
               "Take Profit  = " + DoubleToStr(TP ,digits)  + "\n", 
               "Stop Loss    = " + DoubleToStr(SL  ,digits)  + "\n",                               
               "Risk/Reward  = " + DoubleToStr(RiskReward ,2) + ":1"               
               ) ;
      } // if
      break ; 
   } // if


   } // for

  if(!PB) { deinit() ; } 

  if (ObjectFind(tHIGH0) != 0)
      {
      
          ObjectCreate(tHIGH0,OBJ_HLINE,0,Time[0],Entry);         
          ObjectSet(tHIGH0,OBJPROP_COLOR,colorPBEntry);  
      } 
      else
      {
         ObjectMove(tHIGH0,0,Time[0],X01);
      }
 

    
    if (ObjectFind(tLOW0) != 0)
      {
          ObjectCreate(tLOW0,OBJ_HLINE,0,Time[0],SL);   
          ObjectSet(tLOW0,OBJPROP_COLOR,colorPBStop);
      } 
      else
      {
         ObjectMove(tLOW0,0,Time[0],X02);
      }

//    if(Ask >= X01 ) { target = X01 + (xRange * RiskReward) ; bTarget = true ; }
//    if(Bid <= X02 ) { target = X02 - (xRange * RiskReward) ; bTarget = true ; }    
 
 
   if(bTarget)
   {    
    if (ObjectFind(tTarget) != 0)
      {
          ObjectCreate(tTarget,OBJ_HLINE,0,Time[0],TP);   
          ObjectSet(tTarget,OBJPROP_COLOR,colorPBTarget);
      } 
      else
      {
         ObjectMove(tTarget,0,Time[0],target);  
      }
   }
   else
   {
         ObjectDelete(tTarget); 
   }


   M1_Open = iOpen(symbol,PERIOD_M1,0) ; 
	close   = iClose(symbol,period,0) ; 

if ( Trigger != CurrentTime &&  Sound.Alert ) 
{
   if( M1_Open < X01 && close >= X01 ) { Trigger = CurrentTime ; Alert(symbol,"  ", tChartPeriod, " PB Long Triggered "+ DoubleToStr(X01 ,digits)); }
   if( M1_Open > X02 && close <= X02 ) { Trigger = CurrentTime ; Alert(symbol,"  ", tChartPeriod, " PB Short Triggered "+ DoubleToStr(X02 ,digits)); }     
}

return(0);
}

//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}


//+------------------------------------------------------------------+


/*
http://www.forexfactory.com/showthread.php?t=146556

Ive looked at this on a 1hour time frame and the pattern seems profitable unusable on the 1min as we need a sizable bar to make some pips.

It use 2 bars

The 1st gives us the SL and the TP

Set up for long

A 1hour down candle

Followed by a 1 hour up candle the low of which was supported by the 1st candle,and the size of which is 50% the size no greater

Set up for a short

A 1hour up candle

Followed by a 1 hour down candle the high of which was supported by the 1st candle,and the size of which is 50% the size no greater

SL

The low of either candle for a long
The high of either candle for a short

TP

The high of the 1st candle for a long
The low of the 1st candle for a short

*/

