//+------------------------------------------------------------------+
//|  TRO_SPOKES                                   Madeleine_v2.0.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
//| Madeleine_TRO_MODIFIED_VERSION                                  |
//| MODIFIED BY AVERY T. HORTON, JR. AKA THERUMPLEDONE@GMAIL.COM     |
//| I am NOT the ORIGINAL author 
//  and I am not claiming authorship of this indicator. 
//  All I did was modify it. I hope you find my modifications useful.|
//|                                                                  |
//+------------------------------------------------------------------+
 
 
 
#property indicator_chart_window
 
extern int DrawFromBar = 1 ;
 
extern int cfg_Bars=100;

 
extern bool cfg_Ray=true; 
 

bool  cfg_HL1 =true; 


extern color GridColorHL = Yellow ;
extern color GridColorLH = Orange ;

extern int   GridWide    = 1 ;


      string n05L ;
      string n05H ;
      string n10L ;
      string n10H ;


//+------------------------------------------------------------------+
int init()
  {
 

   deinit();
   
   DrawLine45();
 
   return(0);
  }

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
//+------------------------------------------------------------------+  
int deinit() {

   ObDeleteObjectsByPrefix("trend") ;
   
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
  {
//----
   DrawLine45();
//----
   return(0);
  }
//+------------------------------------------------------------------+
  void DrawLine45()
  {
  
   int hh = Highest(NULL,0,MODE_HIGH,cfg_Bars,0);
   int ll = Lowest(NULL,0,MODE_LOW,cfg_Bars,0); 

   double xRES = iHigh(NULL,0,hh) ;  
   double xSUP = iLow(NULL,0,ll) ; 
  
//     for(int i=1;i<=cfg_Bars;i++)
     {
     
     int i=DrawFromBar;
     
      string ss=TimeToStr(Time[i]);
        for(int j=0;j<StringLen(ss);j++)
        {
         if(StringGetChar(ss,j)=='.' || StringGetChar(ss,j)==':' || StringGetChar(ss,j)==' ')
            ss=StringSetChar(ss,j,'_');
        }

      // spokes 
      
 
        string n0L="trend0L_"+ss;
    
        if(ObjectFind(n0L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n0L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n0L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n0L,OBJPROP_ANGLE,0);
         ObjectSet (n0L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n0L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n0L,OBJPROP_BACK,true);         
        }           

        n05L="trend05L_"+ss;
      
        if(ObjectFind(n05L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n05L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n05L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n05L,OBJPROP_ANGLE,05);
         ObjectSet (n05L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n05L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n05L,OBJPROP_BACK,true);         
        }      

        string n10L="trend10L_"+ss;
    
        if(ObjectFind(n10L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n10L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n10L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n10L,OBJPROP_ANGLE,10);
         ObjectSet (n10L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n10L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n10L,OBJPROP_BACK,true);         
        }        

        string n15L="trend15L_"+ss;
    
        if(ObjectFind(n15L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n15L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n15L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n15L,OBJPROP_ANGLE,15);
         ObjectSet (n15L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n15L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n15L,OBJPROP_BACK,true);         
        }     
        
        string n20L="trend20L_"+ss;
    
        if(ObjectFind(n20L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n20L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n20L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n20L,OBJPROP_ANGLE,20);
         ObjectSet (n20L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n20L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n20L,OBJPROP_BACK,true);         
        }     
        
        
        string n25L="trend25L_"+ss;
    
        if(ObjectFind(n25L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n25L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n25L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n25L,OBJPROP_ANGLE,25);
         ObjectSet (n25L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n25L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n25L,OBJPROP_BACK,true);         
        }                     
        
        string n30L="trend30L_"+ss;
    
        if(ObjectFind(n30L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n30L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n30L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n30L,OBJPROP_ANGLE,30);
         ObjectSet (n30L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n30L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n30L,OBJPROP_BACK,true);         
        }     
        
        string n35L="trend35L_"+ss;
    
        if(ObjectFind(n35L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n35L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n35L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n35L,OBJPROP_ANGLE,35);
         ObjectSet (n35L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n35L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n35L,OBJPROP_BACK,true);         
        }             
        
        string n40L="trend40L_"+ss;
    
        if(ObjectFind(n40L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n40L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n40L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n40L,OBJPROP_ANGLE,40);
         ObjectSet (n40L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n40L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n40L,OBJPROP_BACK,true);         
        }                                   


      string n45L="trend45L_"+ss;

      
        if(ObjectFind(n45L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n45L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n45L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n45L,OBJPROP_ANGLE,45);
         ObjectSet (n45L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n45L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n45L,OBJPROP_BACK,true);         
        }

        string n50L="trend50L_"+ss;
    
        if(ObjectFind(n50L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n50L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n50L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n50L,OBJPROP_ANGLE,50);
         ObjectSet (n50L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n50L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n50L,OBJPROP_BACK,true);         
        }     
        
        string n55L="trend55L_"+ss;
    
        if(ObjectFind(n55L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n55L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n55L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n55L,OBJPROP_ANGLE,55);
         ObjectSet (n55L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n55L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n55L,OBJPROP_BACK,true);         
        }             
                
        string n60L="trend60L_"+ss;
    
        if(ObjectFind(n60L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n60L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n60L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n60L,OBJPROP_ANGLE,60);
         ObjectSet (n60L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n60L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n60L,OBJPROP_BACK,true);         
        }     


        string n65L="trend65L_"+ss;
    
        if(ObjectFind(n65L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n65L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n65L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n65L,OBJPROP_ANGLE,65);
         ObjectSet (n65L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n65L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n65L,OBJPROP_BACK,true);         
        }     

        string n70L="trend70L_"+ss;
    
        if(ObjectFind(n70L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n70L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n70L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n70L,OBJPROP_ANGLE,70);
         ObjectSet (n70L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n70L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n70L,OBJPROP_BACK,true);         
        }     

        string n75L="trend75L_"+ss;
    
        if(ObjectFind(n75L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n75L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n75L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n75L,OBJPROP_ANGLE,75);
         ObjectSet (n75L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n75L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n75L,OBJPROP_BACK,true);         
        }     
        
         string n80L="trend80L_"+ss;
    
        if(ObjectFind(n80L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n80L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n80L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n80L,OBJPROP_ANGLE,80);
         ObjectSet (n80L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n80L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n80L,OBJPROP_BACK,true);         
        }            
        
        string n85L="trend85L_"+ss;
    
        if(ObjectFind(n85L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n85L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n85L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n85L,OBJPROP_ANGLE,85);
         ObjectSet (n85L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n85L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n85L,OBJPROP_BACK,true);         
        }             
        
         string n90L="trend90L_"+ss;
    
        if(ObjectFind(n90L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n90L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n90L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n90L,OBJPROP_ANGLE,90);
         ObjectSet (n90L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n90L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n90L,OBJPROP_BACK,true);         
        }     
        
         string n95L="trend95L_"+ss;
    
        if(ObjectFind(n95L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n95L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n95L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n95L,OBJPROP_ANGLE,95);
         ObjectSet (n95L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n95L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n95L,OBJPROP_BACK,true);         
        }     
        
        string n100L="trend100L_"+ss;
    
        if(ObjectFind(n100L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n100L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n100L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n100L,OBJPROP_ANGLE,100);
         ObjectSet (n100L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n100L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n100L,OBJPROP_BACK,true);         
        }                           
        
        
        string n105L="trend105L_"+ss;
    
        if(ObjectFind(n105L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n105L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n105L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n105L,OBJPROP_ANGLE,105);
         ObjectSet (n105L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n105L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n105L,OBJPROP_BACK,true);         
        }     
        
        string n110L="trend110L_"+ss;
    
        if(ObjectFind(n110L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n110L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n110L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n110L,OBJPROP_ANGLE,110);
         ObjectSet (n110L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n110L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n110L,OBJPROP_BACK,true);         
        }                     
        
        
        string n115L="trend115L_"+ss;
    
        if(ObjectFind(n115L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n115L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n115L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n115L,OBJPROP_ANGLE,115);
         ObjectSet (n115L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n115L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n115L,OBJPROP_BACK,true);         
        }     
        
        string n120L="trend120L_"+ss;
    
        if(ObjectFind(n120L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n120L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n120L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n120L,OBJPROP_ANGLE,120);
         ObjectSet (n120L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n120L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n120L,OBJPROP_BACK,true);         
        }                    
        
        string n125L="trend125L_"+ss;
    
        if(ObjectFind(n125L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n125L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n125L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n125L,OBJPROP_ANGLE,125);
         ObjectSet (n125L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n125L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n125L,OBJPROP_BACK,true);         
        }     
        
         string n130L="trend130L_"+ss;
    
        if(ObjectFind(n130L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n130L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n130L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n130L,OBJPROP_ANGLE,130);
         ObjectSet (n130L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n130L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n130L,OBJPROP_BACK,true);         
        }                    
        
        
        string n135L="trend135L_"+ss;
    
        if(ObjectFind(n135L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n135L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n135L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n135L,OBJPROP_ANGLE,135);
         ObjectSet (n135L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n135L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n135L,OBJPROP_BACK,true);         
        }     
        
        string n140L="trend140L_"+ss;
    
        if(ObjectFind(n140L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n140L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n140L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n140L,OBJPROP_ANGLE,140);
         ObjectSet (n140L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n140L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n140L,OBJPROP_BACK,true);         
        }                    
        
        string n145L="trend145L_"+ss;
    
        if(ObjectFind(n145L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n145L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n145L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n145L,OBJPROP_ANGLE,145);
         ObjectSet (n145L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n145L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n145L,OBJPROP_BACK,true);         
        }      
 
        string n150L="trend150L_"+ss;
    
        if(ObjectFind(n150L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n150L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n150L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n150L,OBJPROP_ANGLE,150);
         ObjectSet (n150L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n150L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n150L,OBJPROP_BACK,true);         
        }      
 
 
        string n155L="trend155L_"+ss;
    
        if(ObjectFind(n155L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n155L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n155L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n155L,OBJPROP_ANGLE,155);
         ObjectSet (n155L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n155L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n155L,OBJPROP_BACK,true);         
        }     
        
         string n160L="trend160L_"+ss;
    
        if(ObjectFind(n160L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n160L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n160L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n160L,OBJPROP_ANGLE,160);
         ObjectSet (n160L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n160L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n160L,OBJPROP_BACK,true);         
        }             
 
 
        string n165L="trend165L_"+ss;
    
        if(ObjectFind(n165L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n165L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n165L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n165L,OBJPROP_ANGLE,165);
         ObjectSet (n165L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n165L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n165L,OBJPROP_BACK,true);         
        }      
 
 
        string n170L="trend170L_"+ss;
    
        if(ObjectFind(n170L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n170L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n170L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n170L,OBJPROP_ANGLE,170);
         ObjectSet (n170L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n170L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n170L,OBJPROP_BACK,true);         
        }      
 
        string n175L="trend175L_"+ss;
    
        if(ObjectFind(n175L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n175L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n175L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n175L,OBJPROP_ANGLE,175);
         ObjectSet (n175L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n175L,OBJPROP_COLOR,GridColorLH);
         ObjectSet (n175L,OBJPROP_BACK,true);         
        }     
        
        string n180L="trend180L_"+ss;
    
        if(ObjectFind(n180L)==-1)
        {
         if (cfg_HL1)
            ObjectCreate(n180L,OBJ_TRENDBYANGLE,0,Time[i], Close[i] );
         ObjectSet (n180L,OBJPROP_RAY,cfg_Ray);
         ObjectSet (n180L,OBJPROP_ANGLE,180);
         ObjectSet (n180L,OBJPROP_TIME2,Time[0]);
         ObjectSet (n180L,OBJPROP_COLOR,GridColorHL);
         ObjectSet (n180L,OBJPROP_BACK,true);         
        }             
        
 
     }
  }
//+------------------------------------------------------------------+


